// Code generated by go-swagger; DO NOT EDIT.

package auth

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// AuthSignInHandlerFunc turns a function with the right signature into a auth sign in handler
type AuthSignInHandlerFunc func(AuthSignInParams) middleware.Responder

// Handle executing the request and returning a response
func (fn AuthSignInHandlerFunc) Handle(params AuthSignInParams) middleware.Responder {
	return fn(params)
}

// AuthSignInHandler interface for that can handle valid auth sign in params
type AuthSignInHandler interface {
	Handle(AuthSignInParams) middleware.Responder
}

// NewAuthSignIn creates a new http.Handler for the auth sign in operation
func NewAuthSignIn(ctx *middleware.Context, handler AuthSignInHandler) *AuthSignIn {
	return &AuthSignIn{Context: ctx, Handler: handler}
}

/*AuthSignIn swagger:route POST /api/auth Auth authSignIn

User authenticate

*/
type AuthSignIn struct {
	Context *middleware.Context
	Handler AuthSignInHandler
}

func (o *AuthSignIn) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewAuthSignInParams()

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
